<?php

namespace common\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use common\models\TemplateLocation;

/**
 * TemplateLocationSearch represents the model behind the search form about `common\models\TemplateLocation`.
 */
class TemplateLocationSearch extends TemplateLocation
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['template_location_id', 'width', 'height', 'sort', 'is_slider', 'is_banner'], 'integer'],
            [['template_location_name', 'template_location_title'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = TemplateLocation::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'template_location_id' => $this->template_location_id,
            'width' => $this->width,
            'height' => $this->height,
            'sort' => $this->sort,
            'is_slider' => $this->is_slider,
            'is_banner' => $this->is_banner,
        ]);

        $query->andFilterWhere(['like', 'template_location_name', $this->template_location_name])
            ->andFilterWhere(['like', 'template_location_title', $this->template_location_title]);

        return $dataProvider;
    }
}
